 /* TFTDExtender - Mod for X-COM: Terror from the Deep
 * NOTE: This project is unfinished. Some of the code is obsolete, useless, or detrimental. Use at your own risk.
 * Original UFO Extender is copyright (C) 2008-2010 Seb76. Initial conversion for X-COM: Terror from the Deep was implemented by Xusilak.
 * Further conversion and updates by <Morgan525/Tycho>.
 * TFTD Patcher is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * TFTD Patcher is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with TFTD Patcher.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "acc.h"
#include "xcom.h"
#include "patcher.h"

static int draw_accuracy=0;
static int current_efficiency;
static int minimum_efficiency;
static int snap_penalty_distance;
static int auto_penalty_distance;
static int orange_cursor_limit=95;
static int red_cursor_limit=75;
void LoadAccuracyParameters()
{
	minimum_efficiency=INI_READ_INT("Range Based Accuracy","Minimum Efficiency",50);
	snap_penalty_distance=INI_READ_INT("Range Based Accuracy","Snap Penalty Distance",30);
	auto_penalty_distance=INI_READ_INT("Range Based Accuracy","Auto Penalty Distance",14);
}

int GetEfficiency(int xpos1,int ypos1,int xpos2,int ypos2)
{
	menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];
	int distance=GetDistance(xpos1, ypos1, xpos2, ypos2);
	int efficiency=100;
	switch(mi->actionType)
	{
		case 1://autoshot: penalty starts at 14 (7 tiles)
			if(distance>auto_penalty_distance)
			{
				efficiency-=(distance-auto_penalty_distance);
			}
			break;
		case 2://snapshot: penalty starts at 30 (15 tiles)
			if(distance>snap_penalty_distance)
			{
				efficiency-=(distance-snap_penalty_distance);
			}
			break;
		case 3://aimedshot: no distance penalty
		default:
			break;
	}

	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	return efficiency;
}


void DrawPCKSpriteCursorHook(__int16 a, __int16 b, int c, int d)
{
	DrawPCKSprite(a,b,c,d);
	
	//		62 -> green
	//		32 -> red
	//		16 -> orange
		current_efficiency=GetEfficiency(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);

		if(draw_accuracy)
		{
			char acc[64];
			int color=62;
			menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];

			if(current_efficiency<orange_cursor_limit)
				color=16;
			if(current_efficiency<red_cursor_limit)
				color=32;

			int accuracy=((int)mi->accuracy*current_efficiency)/100;

//			int distance=GetDistance(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);


//			sprintf(acc,"dist=%d eff=%d acc=%d%% cor=%d%% col=%d r=%d",distance,current_efficiency,(int)mi->accuracy,((int)mi->accuracy*current_efficiency)/100,color,red_cursor_limit);
			sprintf(acc,"%d%%",accuracy);
			DrawString(acc,color,*mouse_ypos-16,*mouse_xpos-16,1);

			draw_accuracy=0;
		}
}

__declspec(naked) void DrawAccuracy(void)
{
	__asm
	{
		mov draw_accuracy,1
		mov cx, word ptr ds:[0x48E4CC] //0x4783A8
		ret
	}
}

void RangeBasedAccuracy()
{
	__asm pusha

	short x1=*(short *)0x48E51C; //was 0x4783F8
	short y1=*(short *)0x48E51E; //0x4783FA
	short x2=*(short *)0x48E524; //0x478400
	short y2=*(short *)0x48E526; //0x478402

	short saved_accuracy=*accuracy;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	*accuracy=(*accuracy*current_efficiency)/100;

	AdjustShotWithAccuracy();

	*accuracy=saved_accuracy;

	__asm popa
}
void ReactionFireAccuracy()
{
	__asm pusha
	//                                   0x4783F8           0x4783FA           0x478400           0x478402
	int distance=GetDistance(*(short *)0x48E51C,*(short *)0x48E51E,*(short *)0x48E524,*(short *)0x48E526);
	int efficiency=100;

	//snapshot: penalty starts at 30 (15 tiles)
	if(distance>snap_penalty_distance)
	{
		efficiency-=(distance-snap_penalty_distance);
	}
	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	current_efficiency=efficiency;

	RangeBasedAccuracy();

	__asm popa
}
